天天看点

Leetcode: Can I Win

refer to https://discuss.leetcode.com/topic/68896/java-solution-using-hashmap-with-detailed-explanation

After solving several "Game Playing" questions in leetcode, I find them to be pretty similar. Most of them can be solved using the top-down DP approach, which "brute-forcely" simulates every possible state of the game.

The key part for the top-down dp strategy is that we need to avoid repeatedly solving sub-problems. Instead, we should use some strategy to "remember" the outcome of sub-problems. Then when we see them again, we instantly know their result. By doing this, we can always reduce time complexity from exponential to polynomial.

(EDIT: Thanks for @billbirdh for pointing out the mistake here. For this problem, by applying the memo, we at most compute for every subproblem once, and there are <code>O(2^n)</code> subproblems, so the complexity is <code>O(2^n)</code> after memorization. (Without memo, time complexity should be like <code>O(n!)</code>)

For this question, the key part is: <code>what is the state of the game</code>? Intuitively, to uniquely determine the result of any state, we need to know:

The unchosen numbers

The remaining desiredTotal to reach

A second thought reveals that 1) and 2) are actually related because we can always get the 2) by deducting the sum of chosen numbers from original desiredTotal.

Then the problem becomes how to describes the state using 1).

In my solution, I use a boolean array to denote which numbers have been chosen, and then a question comes to mind, if we want to use a Hashmap to remember the outcome of sub-problems, can we just use <code>Map&lt;boolean[], Boolean&gt;</code> ? Obviously we cannot, because the if we use boolean[] as a key, the reference to boolean[] won't reveal the actual content in boolean[].

Since in the problem statement, it says <code>maxChoosableInteger</code> will not be larger than <code>20</code>, which means the length of our boolean[] array will be less than <code>20</code>. Then we can use an <code>Integer</code> to represent this boolean[] array. How?

Say the boolean[] is <code>{false, false, true, true, false}</code>, then we can transfer it to an Integer with binary representation as <code>00110</code>. Since Integer is a perfect choice to be the key of HashMap, then we now can "memorize" the sub-problems using <code>Map&lt;Integer, Boolean&gt;</code>.

The rest part of the solution is just simulating the game process using the top-down dp.

他的code精妙之处在于:

1. HashMap的key是由boolean array encode生成的,直接用一个array作hashmap的key是不行的,HashMap fails to get the keys when a different array is passed as key, although the elements are same. (As they are different objects). 感觉用object作key都会有这个问题,除非是同一个object,否则仅仅值相等并不指引正确的位置。所以作者在这里encode成了primative type

2. 14行的结束条件。我曾经想过维护TreeSet, treeset.ceiling(desired) != null表示存在大于desired的unused elem, 则return true; 或者维护一个hashset visited, 然后扫描一遍return true; 这些方法都不如作者的这个来的简洁

3. 22行,我写的时候没有把visited reset为false

Solution 2: 我的backtracking做法,TLE了,但是思路应该还可以, 用的是treeSet,用来表示还可以使用的数,之所以这样做是因为当时只想到return true的base case。不过我的方法好处是不用visited数组